Subject: Re: [PATCHv12 1/4] genirq: Provide a snapshot mechanism for interrupt statistics

From: Thomas Gleixner <[email-masked]>
Date: Tue, 09 Apr 2024 11:58:34 +0200

On Wed, Mar 06 2024 at 20:52, Bitao Hu wrote:
> The soft lockup detector lacks a mechanism to identify interrupt storms
> as root cause of a lockup. To enable this the detector needs a
> mechanism to snapshot the interrupt count statistics on a CPU when the
> detector observes a potential lockup scenario and compare that against
> the interrupt count when it warns about the lockup later on. The number
> of interrupts in that period give a hint whether the lockup might be
> caused by an interrupt storm.
>
> Instead of having extra storage in the lockup detector and accessing
> the internals of the interrupt descriptor directly, convert the per CPU
> irq_desc::kstat_irq member to a data structure which contains the
> counter plus a snapshot member and provide interfaces to take a
> snapshot of all interrupts on the current CPU and to retrieve the delta
> of a specific interrupt later on.
>
> Originally-by: Thomas Gleixner <[email-masked]>
> Signed-off-by: Bitao Hu <[email-masked]>
> Reviewed-by: Liu Song <[email-masked]>
> Reviewed-by: Douglas Anderson <[email-masked]>

This does not apply anymore.

Also can you please split this apart to convert kstat_irqs to a struct
with just the count in it and then add the snapshot mechanics on top.

Thanks,

        tglx